function CarouselController($scope, $rootScope) {

	var currentIndex = 0;
	var carouselWidget = $scope.widget;
	var currentWidget = $scope.widget.widgets[currentIndex];
	var nextWidget, previousWidget;

	if(carouselWidget.widgets.length) {
		carouselWidget.widgets[0].activate();
		$rootScope._currentPopup = carouselWidget.widgets[0];
	}

	carouselWidget.label = currentWidget.label;

	carouselWidget.getPreviousIndex = function() {
		var previousWidget;

		if(currentIndex === 0 && carouselWidget.widgets.length >= 2) {
			previousWidget = carouselWidget.widgets.length - 1;
		} else {
			previousWidget = currentIndex - 1;
		}

		return previousWidget;
	};

	carouselWidget.getNextIndex = function() {
		var nextIndex;

		if(currentIndex == carouselWidget.widgets.length - 1) {
			nextIndex = 0;
		} else {
			nextIndex = currentIndex + 1;
		}

		return nextIndex;
	};

	carouselWidget.nextWidget = function() {
		currentIndex = this.getNextIndex();
		nextWidget = carouselWidget.widgets[currentIndex];

		carouselWidget.label = nextWidget.label;
		nextWidget.activate();
		$rootScope._currentPopup = nextWidget;

		if ($scope.nextWidget) {
			$scope.nextWidget();
		}
	};

	carouselWidget.previousWidget = function() {
		currentIndex = this.getPreviousIndex();
		previousWidget = carouselWidget.widgets[currentIndex];

		carouselWidget.label = previousWidget.label;
		if ($scope.previousWidget) {
			$scope.previousWidget();
		}
		$rootScope._currentPopup = previousWidget;

		previousWidget.activate();
	};

}
